
#include <jni.h>

#define PATH_SEPARATOR ';' /* define it to be ':' on Solaris */
#define USER_CLASSPATH "." /* where Prog.class is */

int main() {
	 jobject demoob; 
    JNIEnv *env;
    JavaVM *jvm;
    jint res, myjint, fint;
    jvalue myjv[2];
	jint answer;
    jclass cls;
    jmethodID mid, mid2 , dconID, dmetID, nvmetid;
    jfieldID fid;
    jstring jstr, jstr2;
    jclass stringClass;
    jobjectArray args;

#ifdef JNI_VERSION_1_2
    JavaVMInitArgs vm_args;
    JavaVMOption options[1];
    options[0].optionString =
        "-Djava.class.path=" USER_CLASSPATH;
    vm_args.version = 0x00010002;
    vm_args.options = options;
    vm_args.nOptions = 1;
    vm_args.ignoreUnrecognized = JNI_TRUE;
/* Create the Java VM */
    res = JNI_CreateJavaVM(&jvm, (void**)&env, &vm_args);
#else
    JDK1_1InitArgs vm_args;
    char classpath[1024];
    vm_args.version = 0x00010001;
    JNI_GetDefaultJavaVMInitArgs(&vm_args);
    /* Append USER_CLASSPATH to the default system class path */
    sprintf(classpath, "%s%c%s",
            vm_args.classpath, PATH_SEPARATOR, USER_CLASSPATH);
    vm_args.classpath = classpath;
/* Create the Java VM */
    res = JNI_CreateJavaVM(&jvm, &env, &vm_args);
#endif /* JNI_VERSION_1_2 */

if (res < 0) {
        fprintf(stderr, "Can't create Java VM\n");
        exit(1);
    }
    cls = (*env)->FindClass(env, "Prog4");
    if (cls == 0) {
        goto destroy;
    }
 
    mid = (*env)->GetStaticMethodID(env, cls, "main",
                                    "([Ljava/lang/String;)V");
    if (mid == 0) {
        goto destroy;
    }
    mid2 = (*env)->GetStaticMethodID(env, cls, "demo",
                                    "(ILjava/lang/String;)I");
    if (mid2 == 0)
	printf("cannot get demo method.");
    jstr = (*env)->NewStringUTF(env, " from C, yes C!"); 
    if (jstr == 0) {
        goto destroy;
    }
    stringClass = (*env)->FindClass(env, "java/lang/String");
    args = (*env)->NewObjectArray(env, 1, stringClass, jstr);
    if (args == 0) {
        goto destroy;
    }
    (*env)->CallStaticVoidMethod(env, cls, mid, args);
printf("before myjint\n");
    myjint = (jint) 3;
/*
    answer = (*env)->CallStaticIntMethod(env, cls, mid2, myjint);
	if (answer == 0) {
        	(*env)->ExceptionDescribe(env);
        	(*env)->ExceptionClear(env);
	}
*/
printf("after myjint\n");
    myjv[0].i = (jint) 756;
    jstr2 = (*env)->NewStringUTF(env, " suffix!"); 
	if (jstr2 == 0) {
        	(*env)->ExceptionDescribe(env);
        	(*env)->ExceptionClear(env);
	}
    myjv[1].l = (jobject) jstr2;
    answer = (*env)->CallStaticIntMethodA(env, cls, mid2, myjv);
    printf("ans = %d\n", (int)answer);

/* build new object */
 printf("prior to build\n");
	dconID = (*env)->GetMethodID( env, cls, "<init>", "()V");
	if (dconID == 0) {
        	(*env)->ExceptionDescribe(env);
        	(*env)->ExceptionClear(env);
	}
		
	demoob = (*env)->NewObject( env, cls, dconID, NULL );
	if (demoob == 0) {
        	(*env)->ExceptionDescribe(env);
        	(*env)->ExceptionClear(env);
	}
	dmetID = (*env)->GetStaticMethodID( env, cls, "demo", 
			"(ILjava/lang/String;)I");
	if (dmetID == 0) {
        	(*env)->ExceptionDescribe(env);
        	(*env)->ExceptionClear(env);
	}
    answer = (*env)->CallStaticIntMethodA(env, cls, dmetID, myjv);
	fid = (*env)->GetStaticFieldID( env, cls, "xx", 
			"I");
	if (fid == 0) {
        	(*env)->ExceptionDescribe(env);
        	(*env)->ExceptionClear(env);
	}
	fint = (*env)->GetStaticIntField(env, cls, fid);
	printf("xx = %d\n", (int)fint);

	nvmetid = (*env)->GetMethodID( env, cls, "nonvir", "()V" ); 
	if (nvmetid == 0) {
        	(*env)->ExceptionDescribe(env);
        	(*env)->ExceptionClear(env);
	}
	(*env)->CallNonvirtualVoidMethod(env, demoob, cls, nvmetid);
	if ((*env)->ExceptionOccurred(env)) {
        	(*env)->ExceptionDescribe(env);
        	(*env)->ExceptionClear(env);
	}


destroy:
    if ((*env)->ExceptionOccurred(env)) {
        (*env)->ExceptionDescribe(env);
    }
    (*jvm)->DestroyJavaVM(jvm);
    return 0;
}
