
/*
# copyright 2005 VJ Carey
# all rights reserved
#
*/

#include <stdio.h>

#include <R.h>
#include <Rdefines.h>
#include <Rinternals.h>

#define WrapRptr(gptr,tag,vval) \
if (gptr == NULL) \
  return R_NilValue;\
else\
  {\
  SEXP vval = R_MakeExternalPtr( gptr, tag, R_NilValue );\
  return vval ;\
  }

#define WrapRptrNoRet(gptr,tag,vval) \
if (gptr == NULL) \
  {\
  SEXP vval = R_NilValue;\
  }\
else\
  {\
  SEXP vval = R_MakeExternalPtr( gptr, tag, R_NilValue );\
  }

static SEXP JNIEnv_type_tag;
static SEXP JavaVM_type_tag;


#define CHECK_JNIEnv(s) do { \
    if (TYPEOF(s) != EXTPTRSXP || \
        R_ExternalPtrTag(s) != JNIEnv_type_tag) \
        error("bad JNIEnv reference"); \
    if ( (JNIenv *)R_ExternalPtrAddr(s) == (JNIEnv *)NULL ) \
	error("JNIEnv pointer is null"); \
} while (0)

#define CHECK_JavaVM(s) do { \
    if (TYPEOF(s) != EXTPTRSXP || \
        R_ExternalPtrTag(s) != JavaVM_type_tag) \
        error("bad JavaVM reference"); \
    if ( (jvm *)R_ExternalPtrAddr(s) == (jvm *)NULL ) \
	error("JavaVM pointer is null"); \
} while (0)


SEXP arji_init(void)
{
	JNIEnv_type_tag = install("JNIENV_TYPE_TAG");
	JavaVM_type_tag = install("JAVAVM_TYPE_TAG");
	return R_NilValue;
}

